/******************************************************************************
* NORTi LAN Controller Driver (for NORTiSim)                                  *
*                                                                             *
*  Copyright (c) 2002, MiSPO Co., Ltd.                                        *
*  All rights reserved.                                                       *
*                                                                             *
******************************************************************************/


#include <string.h>
#ifndef NULL
  #include <stdio.h>
#endif
#include "norti3.h"
#include "nonet.h"
#include "nonets.h"
#define INCLUDED_FROM_NONET
#include "nonetc.h"

#include "nosimapi.h"
#include "nonwin.h"
/* ------------------------------------------------------------------------ */

/* LANRg[ubŇ^ */

typedef struct t_lan {
    ID   rxtid;      /* M҂^XNID */
    UH   rxpos;      /* MpPbgǂݍݍς݃oCgJEg */
    UH   rxpacz;     /* MpPbgTCY */
    UB   *rxpac;     /* MpPbg */

    ID   txtid;      /* M҂^XNID */
    UH   txpos;      /* MpPbgݍς݃oCgJEg */
    UH   txpacz;     /* MpPbgTCY */
    UB   *txpac;     /* MpPbg */
}  T_LAN;

/* ϐ */

static T_LAN lan;
/* ------------------------------------------------------------------------ */
#define ETH_MAX_LEN   1514                  /* maximum length of packet     */
/* ------------------------------------------------------------------------ */

/*****************************************************************************
* LAN Rg[
*
* macaddr   MACAhX(6oCg̔z)ւ̃|C^
******************************************************************************/

extern ER lan_ini( UB *macaddr )
{  /* NICLANhCȍ */
  nic_set_mac_addr( macaddr );
  nic_set_lan_isr( lan_intr );
  def_int( nic_get_irq_num(), &dint_lan );
  nic_set_imr_flag( IMR_PRX | IMR_PTX );
  return( nic_sta()  ?  E_OK : -1 );
}

/*****************************************************************************
* M݃nh
*
******************************************************************************/

extern void lan_intr( void )
{
    UB isr;
    ID tid = 0;

  isr = (UB)nic_get_isr_flag();
  isr &= (ISR_PRX | ISR_PTX);
  nic_clr_isr_flag( isr );

  if ( (isr & ISR_PRX) && lan.rxtid )
  {
    tid = lan.rxtid;
    wup_tsk( tid );
    lan.rxtid = 0;
  }
  if ( (isr & ISR_PTX) && lan.txtid )
  {
    tid = lan.txtid;
    wup_tsk( tid );
    lan.txtid = 0;
  }
}


/*****************************************************************************
* Mݑ҂
*
******************************************************************************/

extern ER lan_wai_rcv( TMO tmout )
{  /* 荞݂̎gpO */
    ER er = E_OK;
  while ( 1 )
  {
    /* 悸͎MꂽpPbg邩 */
    if ( nic_get_rx_count() )  break;

    /* ȂM荞ݑ҂ */
    lan.rxtid = vget_tid();
    nic_set_imr_flag( IMR_PRX );
    er = tslp_tsk( tmout );
    nic_clr_imr_flag( IMR_PRX );

    if ( er != E_OK )
    {  lan.rxtid = 0;  break;  }
  }
  return( E_OK );
}

/*****************************************************************************
* Mݑ҂
*
******************************************************************************/

extern ER lan_wai_snd( TMO tmout )
{
    ER er = E_OK;
  while ( nic_inq_tx_reqed() )
  {  /* 悸͑MĂ邩AĂȂȂ҂ */
    lan.txtid = vget_tid();
    nic_set_imr_flag( IMR_PTX );
    er = tslp_tsk( tmout );
    nic_clr_imr_flag( IMR_PTX );

    if ( er != E_OK )
    {  lan.txtid = 0;  break;  }
  }
  return( er );
}

/*****************************************************************************
* MpPbg𓾂
*
******************************************************************************/

extern ER lan_get_len( UH *len )
{
    UH pacz = (UH)nic_ext_rx_pac();
  if ( pacz > ETH_MAX_LEN )  {  lan_get_end();  return( -1 );  }

  lan.rxpac = nic_get_rx_buf();
  lan.rxpos = 0;
  lan.rxpacz = pacz;
  *len = pacz;
  return( E_OK );
}

/*****************************************************************************
* MpPbgǂݏo
*
* buf   ǂݏo߂̃obt@
* len   ǂݏooCg
******************************************************************************/

extern ER lan_get_pkt( void *buf, int len )
{
    UB *bufy = (UB *)buf, *pac = lan.rxpac;
    int n, npos = lan.rxpos;
  for ( n = 0; n < len;  ++n, ++npos )
    bufy[n] =  pac[npos];

  lan.rxpos += (UH)len;
  return( E_OK );
}

/*****************************************************************************
* MpPbgǂݏoI
*
******************************************************************************/

extern ER lan_get_end( void )
{
  nic_rel_rx_pac();
  lan.rxpac  = 0;
  lan.rxpos  = 0;
  lan.rxpacz = 0;
  return( E_OK );
}

/*****************************************************************************
* MpPbgǂݔ΂
*
* len   MpPbg̖ǃoCg
******************************************************************************/

extern ER lan_skp_pkt( int len )
{
  lan.rxpos += (UH)len;
  if ( lan.rxpos >= lan.rxpacz )
    lan_get_end();
  return( E_OK );
}

/*****************************************************************************
* MpPbgݒ
*
******************************************************************************/

extern ER lan_set_len( int len )
{
  nic_set_tx_len( (UINT)len );
  lan.txpac = nic_get_tx_buf();
  lan.txpos = 0;
  lan.txpacz = (UH)len;
  return( E_OK );
}

/*****************************************************************************
* MpPbg
*
* data      ރf[^
* len       f[^̃oCgi> 0j
******************************************************************************/

extern ER lan_put_pkt( const void *data, int len )
{
    const UB *bufy = (const UB *)data;
    UB *pac = lan.txpac;
    int n, npos = lan.txpos;

  for ( n = 0; n < len;  ++n, ++npos )
    pac[npos] =  bufy[n];

  lan.txpos += (UH)len;
  return( E_OK );
}

/*****************************************************************************
* MpPbg60oCg̏ꍇ̃_~[
*
* len       _~[f[^̃oCgi> 0j
******************************************************************************/

extern ER lan_put_dmy( int len )
{
    UB *pac = lan.txpac;
    int n, npos = lan.txpos;

  for ( n = 0; n < len; ++n, ++npos )
    pac[npos] = 0x00;

  lan.txpos += (UH)len;
  return( E_OK );
}

/*****************************************************************************
* MpPbgݏI
*
******************************************************************************/

extern ER lan_put_end( void )
{  /* MvTCYputTCY̔r͎肠Ȃ */
  nic_req_tx_pac();
  return( E_OK );
}
/* ------------------------------------------------------------------------ */

